#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include "timer.h"

/*internal functions */
double get_elapsed(struct timeval *);

/*-----------------------------------------------------------*/
char *TimerFunc(int which_function, long nradd) { 

	static struct timeval start;
	static long nrbytes;
	static char retdisp[256];
	static char none[] = { "" };	

	double elapsed, bps;
	char *retval = none;

	switch(which_function) {
	  case TIMER_START:
		nrbytes = 0L;
		gettimeofday(&start, NULL);
		break;
	  case TIMER_ADDBYTES:
		nrbytes += nradd;
		break;
	  case TIMER_DISPLAY:
		if(nrbytes > 0) {
			elapsed = get_elapsed(&start);
			bps = (elapsed > 0.0) ? bps = nrbytes / elapsed : 0.0;
			sprintf(retdisp,"%10.1f BPS", bps);
			retval = retdisp;
		}
		break;
	case TIMER_TOTALS:
		elapsed = get_elapsed(&start);
		bps = (elapsed > 0.0 && nrbytes > 0) ? bps = nrbytes / elapsed : 0.0;
		sprintf(retdisp, "%ld Bytes Received in %.2f seconds, BPS = %-10.1f", nrbytes, elapsed, bps);
		retval = retdisp;
		break;	
	  default:
		/* ignore invalid commands */
		break;
	}
	return retval;
}
/*-----------------------------------------------------------------------------------*/
double get_elapsed(struct timeval *start) {
	struct timeval curr;
	double elapsed;

	/* compute elapsed time, in seconds */
	gettimeofday(&curr, NULL);
	elapsed = curr.tv_sec - start->tv_sec;
	elapsed += (((double) (curr.tv_usec - start->tv_usec)) / 1000000.0);

	return elapsed;
}
